/////////////////////////////////////////////////////////////////
//Die Standard-Map wird für die immer gleichen zufälligen Startwerte  
//bei immer größer werdendem K-Wert gezeichnet.
//Noch kein Zoomen oder Trajektorien-Hervorhebung.
//Nur 30 zufällige StartPunkt, damit schneller gezeichnet wird.
//Jedem Startpunkt ist jeweils die gleiche Farbe zugeordnet
//////////////////////////////////////////////////////////////

//Bildausschnitt zu Beginn:
float xU = 0; float xO = 1;
float yU = 0  ; float yO = 1;
ArrayList<StartPunkt> startPunkte= new ArrayList<StartPunkt>();
double  xUNeu, xONeu, yUNeu, yONeu,xAlt, yAlt, xNeu, yNeu;
double   xH, yH; 
PFont font;
int w = 600; int h = 600; 
int xK, yK; //Koordinaten der Punkte
int n, i, l, L;
int f; //für die Farbe
float K;
String KText;

///////////////////////////////////////////////////////////////////////////
void setup(){ 
  background(0); //strokeWeight(2);
  fill(255);
  size(600,600);
  smooth();
  textSize(16);
  i=0;
  K = 0.1; 
  KText = nf(K,1,2);
 // text("K = "+KText, 20, 20);
  n= 10000;  //n...Anzahl der Iterationen
  L =30; //L ZufallsStartPunkt
  //L Zufallsstartpunkte bestimmen
  for(l=0; l<L;l++){
     yH = random(0,1); xH =random(0,1);    
     StartPunkt neuerPunkt = new StartPunkt(xH,yH);
     startPunkte.add(neuerPunkt);
  }
  xUNeu = 0; xONeu = 0;
  yUNeu = 0; yUNeu = 0;  
   text("K = "+KText, 20, 20);//aktuellen Parameter anzeigen
}
 
 void draw(){//Maps mit variierendem Parameter K zeichnen
    background(0);
    text("K = "+KText, 20, 20);
    for(StartPunkt punkt: startPunkte){
        iteriere(punkt.getX(),punkt.getY(),n,K);
        
     }
     f=0;
     K=(K+0.01)%5;  
     KText = nf(K,1,2);
     text("K = "+KText, 20, 20);    
 }
//Aus gegebenem Startpunkt (xH,yH) die folgenden n Punkte berechnen
////////////////////////////////////////////////////////
void iteriere(double xH, double yH, int N ,float K){  
  colorMode(HSB,256,256,256); 
  this.K =K;
  xAlt = xH; 
  yAlt = yH;
  point(xK,yK); 
  n =   N;
  stroke(color(f%256,255,255));
  
  while(i <=n){  //auf 1 normierte Form
       yNeu = (yAlt + K*Math.sin(2*PI*xAlt)/(2*PI)) % 1; 
       xNeu = (xAlt + yNeu) % 1;  
       // if(i == 10)println(xNeu,yNeu);
       if(xNeu <0) xNeu = xNeu +1;//damit  xNeu > 0
       if(yNeu <0) yNeu = yNeu +1;//damit  xNeu > 0
       yK = round( map((float)yNeu,yU,yO,h,0));                 
       xK = round (map((float)xNeu,xU,xO,0,w));  
       point(xK,yK);     
       xAlt = xNeu;
       yAlt = yNeu;
       i++; 
  }
   i=0;  f=f+20;  
}

////////////////////////////////////////////////////////////////////////////
//Klasse für die Punkte
//////////////////////////////////////////////////////////////////////////////
public class StartPunkt {

 //Attribute
 private double x;
 private double y;

 
 //Konstruktor
 public StartPunkt(double x, double y) {
   this.x = x;
   this.y = y;
 }

// Anfang Methoden
 public double getX() {
    return x;
 }
  
  public void setX(double x) {
    this.x = x;
  }
  
  public double getY() {
    return y;
  }
  
  public void setY(double y) {
    this.y = y;
  }
  
  
 


  
  
  

 
}
